# dcforumlib.pl
# Part of DCForum99 by DCScripts
# Contains common functions used by various dcscripts
#
# As part of the installation process, you will be asked
# to accept the terms of this Agreement. This Agreement is
# a legal contract, which specifies the terms of the license
# and warranty limitation between you and DCScripts and DCForum.
# You should carefully read this terms agreement as outlined in
# the readme.txt file included with this distribution before
# installing or using this software.  Unless you have a different license
# agreement obtained from DCScripts, installation or use of this software
# indicates your acceptance of the license and warranty limitation terms
# contained in this Agreement. If you do not agree to the terms of this
# Agreement, promptly delete and destroy all copies of the Software.
###################################################################
##  German translation by Lothar Jung for Webster Internet Dienstleistungen
##  http://Webster.de/dcscripts/
###################################################################


#>>>>>>>>>>>>>>> Keine &Auml;nderungen in diesem Script erforderlich <<<<<<<<
####
#
# subroutine create_button
#
####

sub create_button {

   my ($type,$r_in,$r_setup) = @_;
   my $menu_buttons = "";
   my $icon_text;

   my $b_login = " [<a href=\"$dclogin\"><b>Login/Logout</b></a>] ";
   my $b_lobby = " [<a href=\"$boardurl\"><b>Lobby</b></a>] ";
   my $b_main = " [<a href=\"$boardurl?az=list&forum=$forum\"><b>Forum-Inhalt</b></a>] ";
   my $b_post = " [<a href=\"$dcpost?az=post&forum=$forum\"><b>Schreiben</b></a>] ";
   my $b_mark = " [<a href=\"$exurl?az=mark&forum=$forum\"><b>Forum&nbsp;markieren</b></a>] ";
   my $b_help = " [<a href=\"$helpurl\"><b>Hilfe</b></a>] ";
   my $b_search = " [<a href=\"$exurl?az=search_form\"><b>Suchen</b></a>] ";

   my $b_admin = " [<a href=\"$adminurl\"><b>Admininstration</b></a>] ";
   my $b_profile = " [<a href=\"$dcuser\"><b>User-Registrierung</b></a>] ";

   if ($r_setup->{'board_setup'}->{'use_icons'} eq "on") {
		if (-e "$imgdir/left_e.gif") {
         $b_left = "<img 
				src=\"$imgurl/left_e.gif\" border=\"0\"></a>";
         $b_right = "<img 
				src=\"$imgurl/right_e.gif\" border=\"0\"></a>";
		}
         $b_login = "<a href=\"$dclogin\"><img 
				src=\"$imgurl/login.gif\" alt=\"Klicken Sie hier um sich ein- auszuloggen\" border=\"0\"></a>";
         $b_login = "<a href=\"$dclogin\"><img 
				src=\"$imgurl/login.gif\" alt=\"Klicken Sie hier um sich ein- auszuloggen\" border=\"0\"></a>";
         $b_lobby = "<a href=\"$boardurl\"><img 
				src=\"$imgurl/mainforum.gif\" alt=\"Zur Forenuebersicht/Lobby\" border=\"0\"></a>";
         $b_main = "<a href=\"$boardurl?az=list&forum=$forum\"><img 
				src=\"$imgurl/home.gif\" alt=\"Zur&uuml;ck zum Inhalt\" border=\"0\"></a>";
         $b_post = "<a href=\"$dcpost?az=post&forum=$forum\"><img 
				src=\"$imgurl/post.gif\" alt=\"Neuen Beitrag schreiben\" border=\"0\"></a>";
         $b_mark = "<a href=\"$exurl?az=mark&forum=$forum\"><img 
				src=\"$imgurl/mark.gif\" alt=\"Forum als gelesen markieren\" border=\"0\"></a>";
         $b_help = "<a href=\"$helpurl\"><img 
				src=\"$imgurl/help.gif\" alt=\"Hilfe zu diesem Forum anzeigen\" border=\"0\"></a>";
         $b_search = "<a href=\"$exurl?az=search_form\"><img 
				src=\"$imgurl/search.gif\" alt=\"In den Forumsbeitraegen suchen\" border=\"0\"></a>";
         $b_admin = "<a href=\"$adminurl\"><img 
				src=\"$imgurl/admin.gif\" alt=\"Zum Adminbereich von DCForum\" border=\"0\"></a>";
         $b_profile = "<a href=\"$dcuser\"><img 
				src=\"$imgurl/profile.gif\" alt=\"User Profilmanager/Registrierung\" border=\"0\"></a>";
   }

   if ($type eq 'list') {
         $menu_buttons .= "$b_left$b_login$b_lobby$b_post$b_mark$b_help$b_search";
         $icon_text ="[ LOGIN | LOBBY/&Uuml;BERSICHT | SCHREIBEN | MARKIEREN | HILFE | SUCHEN ]";

		if ($session) {
  		   $menu_buttons .= "$b_profile";
		   chop($icon_text);
		   $icon_text .= "| USER MANAGER]";
		}
		
      if ($r_in->{'userdata'}->{'Group'} eq "admin" or 
			$r_in->{'userdata'}->{'Group'} eq "moderator") {
  		   $menu_buttons .= "$b_admin";
		   chop($icon_text);
		   $icon_text .= "| ADMINISTRATION ]";
	   }

  		   $menu_buttons .= "$b_right";

   }
   elsif ($type eq 'admin') {
         $menu_buttons .= "$b_left$b_login$b_lobby$b_admin";
   }
   elsif ($type eq 'user_menu') {
         $menu_buttons .= "$b_left$b_lobby$b_help$b_search";
         $icon_text ="[ LOBBY/&Uuml;BERSICHT | HILFE | SUCHEN ]";

		if ($session) {
  		   $menu_buttons .= "$b_profile";
		   chop($icon_text);
		   $icon_text .= "| USERMANAGER ]";
		}
		
      if ($r_in->{'userdata'}->{'Group'} eq "admin" or 
			$r_in->{'userdata'}->{'Group'} eq "moderator") {
  		   $menu_buttons .= "$b_admin";
		   chop($icon_text);
		   $icon_text .= "| ADMINISTRATION ]";
	   }

  		   $menu_buttons .= "$b_right";

   }
  elsif ($type eq 'message') {
      $menu_buttons .= "$b_left$b_lobby$b_main$b_help$b_search$b_right";
       $icon_text = "[ LOBBY/&Uuml;BERSICHT | FORUM&Uuml;BERSICHT | HILFE | SUCHEN ]";
   }
   elsif ($type eq 'help') {

      $menu_buttons .=qq~
         $b_left$b_login$b_lobby$b_search$b_right
      ~;
         $icon_text = "[ LOGIN | LOBBY/&Uuml;BERSICHT | SUCHEN ]";

   }
   elsif ($type eq 'search') {

      $menu_buttons .=qq~
         $b_left$b_login$b_lobby$b_help$b_right
      ~;
         $icon_text = "[ LOGIN | LOBBY/&Uuml;BERSICHT | HILFE ]";

   }
   elsif ($type eq 'new_message') {

      my $user;

      $menu_buttons ="$b_left$b_login$b_lobby";

      if ($r_in->{'userdata'}->{'Username'}) {
         $user = $r_in->{'userdata'}->{'Username'};
      }

      $b_mark = "[<a href=\"$exurl?az=mark&forum=all\"><b>Foren markieren</b></a>]";
      if ($r_setup->{'board_setup'}->{'use_icons'} eq "on") {
         $b_mark = "<a href=\"$exurl?az=mark&forum=all\"><img src=\"$imgurl/mark.gif\" alt=\"Forum als gelesen markieren\" border=\"0\"></a>";
      }

      if ($user) {
            $menu_buttons .= "$b_mark";
      }

      $menu_buttons .= "$b_help$b_search";

      if ($user) {
         $icon_text = "[ LOGIN | LOBBY/&Uuml;BERSICHT | ALLE MARKIEREN | HILFE | SUCHEN ]"
      }
      else {
         $icon_text = "[ LOGIN | HELP | SEARCH ]";
      }

      if ($r_in->{'userdata'}->{'Group'} eq "admin" or 
			$r_in->{'userdata'}->{'Group'} eq "moderator") {
  		   $menu_buttons .= "$b_admin";
		   chop($icon_text);
		   $icon_text .= "| ADMINISTRATION ]";
	   }
  		   $menu_buttons .= "$b_right";

  }
   elsif ($type eq 'list_forums') {

      my $user;

      $menu_buttons ="$b_left$b_login";

      if ($r_in->{'userdata'}->{'Username'}) {
         $user = $r_in->{'userdata'}->{'Username'};
      }

      my $b_new = "[<a href=\"$exurl?az=n_mesg&user=$user\"><b>New Messages</b></a>]";
      $b_mark = "[<a href=\"$exurl?az=mark&forum=all\"><b>Mark Forums</b></a>]";
      if ($r_setup->{'board_setup'}->{'use_icons'} eq "on") {
         $b_mark = "<a href=\"$exurl?az=mark&forum=all\"><img src=\"$imgurl/mark.gif\" alt=\"Forum als gelesen markieren\" border=\"0\"></a>";
         $b_new = "<a href=\"$exurl?az=n_mesg&user=$user\"><img src=\"$imgurl/allnew.gif\" alt=\"Alle neuen Beitraege anzeigen\" border=\"0\"></a>";
      }

      if ($user) {
            $menu_buttons .= "$b_new$b_mark";
      }

      $menu_buttons .= "$b_help$b_search";

      if ($user) {
         $icon_text = "[ LOGIN | NEUE | ALLE MARKIEREN | HILFE | SUCHEN ]"
      }
      else {
         $icon_text = "[ LOGIN | HILFE | SUCHEN ]";
      }

		if ($user) {
  		   $menu_buttons .= "$b_profile";
		   chop($icon_text);
		   $icon_text .= "| USERMANAGER ]";
		}

      if ($r_in->{'userdata'}->{'Group'} eq "admin" or 
			$r_in->{'userdata'}->{'Group'} eq "moderator") {
  		   $menu_buttons .= "$b_admin";
		   chop($icon_text);
		   $icon_text .= "| ADMINISTRATION ]";
	   }

  		   $menu_buttons .= "$b_right";

  }

	
   $menu_buttons = "<font size=\"$font_size_3\" color=\"$font_color_3\" 
			face=\"$font_face_1\">$menu_buttons</font><br>";

   if ($r_setup->{'board_setup'}->{'icon_text'} eq "on" &&
         $r_setup->{'board_setup'}->{'use_icons'} eq "on" ) {
      $menu_buttons .= qq~
         <font size="1"  color="$font_color_3" face="$font_face_3">
         $icon_text
         </font>~;
   }
     
  $menu_buttons;
}

#####
#
# subroutine get_table_heading
# generate table heading for Main Listing
#
#####

sub get_table_heading {

	my $flag = shift;
	my $table_heading;
	
	if ($flag) {
	   $table_heading .= qq~
    	<TR BGCOLOR="$bg_color_0">
	      <TH ALIGN="LEFT">
				<font SIZE="$font_size_0" FACE="$font_face_0" color="$font_color_0">
	               Thema</font></TH>
	      <TH ALIGN="LEFT">
	         <font SIZE="$font_size_0" FACE="$font_face_0" color="$font_color_0">
	               Information</font></TH></TR>~;
	}
	else {
	   $table_heading .= qq~
    	<TR BGCOLOR="$bg_color_0">
	      <TH ALIGN="CENTER">
				<font SIZE="$font_size_0" FACE="$font_face_0" color="$font_color_0">
	               Thema</font></TH>
	      <TH ALIGN="CENTER">
	         <font SIZE="$font_size_0" FACE="$font_face_0" color="$font_color_0">
	               Geschrieben&nbsp;von</font></TH>
	      <TH ALIGN="CENTER" WIDTH="150">
	         <font SIZE="$font_size_0" FACE="$font_face_0" color="$font_color_0">
	            Letzte&nbsp;Antwort&nbsp;geschrieben&nbsp;am</font></TH>
	      <TH ALIGN="CENTER">
	         <font SIZE="$font_size_0" FACE="$font_face_0" color="$font_color_0">
	            Antworten</font></TH></TR>~;
	}
  return $table_heading;

}

#####
#
#   subroutine get_setup_variables
#   displays the form for creating a new forum
#
#####

sub get_setup_variables {

  my($datafile,$r_in) = @_;

  $r_rows = readdata("$datafile");   
  
  foreach (@$r_rows) {
    chomp($_);

# BIG5
#    ($key,$value) = split(/::/,$_);
    ($key,$value) = split(/\|/,$_);
    $r_in->{$key} = $value;
  }
}

###
#
# get_forum_info
#
###

sub get_forum_info {

	my($forum_file,$r_setup) = @_;
	my $r_lines = readdata($forum_file);
	foreach (@$r_lines) {
		chomp;
# BIG5
#		my @temp = split /::/;
		my @temp = split /\|/;
		push(@{$r_setup->{'forums'}},$temp[0]);
		$r_setup->{'forum_conf'}->{$temp[0]} = $temp[1];
		$r_setup->{'forum_name'}->{$temp[0]} = $temp[2];
		$r_setup->{'forum_desc'}->{$temp[0]} = $temp[3];
		$r_setup->{'forum_owner'}->{$temp[0]} = $temp[4];
		$r_setup->{'forum_owner_email'}->{$temp[0]} = $temp[5];
		$r_setup->{'forum_type'}->{$temp[0]} = $temp[6];
		$r_setup->{'forum_status'}->{$temp[0]} = $temp[7];
		$r_setup->{'forum_last'}->{$temp[0]} = $temp[8];
		$r_setup->{'forum_threads'}->{$temp[0]} = $temp[9];
		$r_setup->{'forum_archive'}->{$temp[0]} = $temp[10];
	}
}	

###
#
# save_forum_info
#
###

sub save_forum_info {

	my ($forum_file,$r_setup) = @_;

	foreach $forum (@{$r_setup->{'forums'}}) {

# BIG5
#			my $temp = join("::",
			my $temp = join("\|",
			$forum,
			$r_setup->{'forum_conf'}->{$forum},
			$r_setup->{'forum_name'}->{$forum},
			$r_setup->{'forum_desc'}->{$forum},
			$r_setup->{'forum_owner'}->{$forum},
			$r_setup->{'forum_owner_email'}->{$forum},
			$r_setup->{'forum_type'}->{$forum},
			$r_setup->{'forum_status'}->{$forum},
			$r_setup->{'forum_last'}->{$forum},
			$r_setup->{'forum_threads'}->{$forum},
			$r_setup->{'forum_archive'}->{$forum} );
		push(@new_row,"$temp\n");
	}

	writedata($forum_file,\@new_row);

}
###
### subroutine forum_links
###

sub forum_links {

	my ($r_in,$r_setup) = @_;

   my $r_conf = readdata("$password_file_dir/$conf_file");

	foreach (@{$r_setup->{'forums'}}) {
		if ($r_setup->{'forum_status'}->{$_} eq "on" && 
			check_forum_access($r_in,$r_setup,$_) ) {
			$r_conf_forums->{$r_setup->{'forum_conf'}->{$_}} = undef;
			$r_conf_count->{$r_setup->{'forum_conf'}->{$_}} = undef;
		}
	}

	foreach (@{$r_setup->{'forums'}}) {
		if ($r_setup->{'forum_status'}->{$_} eq "on" && 
			check_forum_access($r_in,$r_setup,$_) ) {
			push( @{ $r_conf_forums->{$r_setup->{'forum_conf'}->{$_}} } , $_);
			$r_conf_count->{$r_setup->{'forum_conf'}->{$_}}++;
		}
	}

	# Some javascript stuff for drop and jump effect

   my $html_forum_links .= qq~
<script language="javascript">
function MakeArray() {
   this.length = MakeArray.arguments.length
   for (var i = 0; i < this.length; i++)
   this[i+1] = MakeArray.arguments[i]
}

var url = new MakeArray("","$boardurl",\n~;

   foreach (@{$r_conf}) {
		chomp;
# BIG5
#		my ($conf_id,$conf_name,$conf_desc,$conf_status) = split /::/;
		my ($conf_id,$conf_name,$conf_desc,$conf_status) = split /\|/;
		if ($r_conf_count->{$conf_id}) {
			$html_forum_links .= "\"$boardurl?conf=$conf_id\",\n";
		   foreach (@{ $r_conf_forums->{$conf_id} }) {
				   $html_forum_links .= "\"$boardurl?az=list&forum=$_\",\n";
			}
		}
	}

	chomp($html_forum_links);
	chop($html_forum_links);

	$html_forum_links .= qq~
	)
	
function jumpPage(form) {
i = form.forum.selectedIndex;
if (i == 0) return;
    window.location.href = url[i+1];
}
</script>
<!-- BEGIN FORUM LINKS -->
<TABLE BORDER="0" WIDTH="$table_width" CELLPADDING="3" cellspacing="1">
	 <TR BGCOLOR="$bg_color_0">
      <TD ALIGN="RIGHT" VALIGN="TOP">
			<FORM ACTION="$boardurl" METHOD="POST">
			<input type="hidden" name="az" value="list">
      	<FONT SIZE="2" COLOR="$font_color_0" FACE="$font_face_0">
			<select name="forum" onChange="jumpPage(this.form)">
			<option value="">Zu einem anderen Forum wechseln
			<option value="LOBBY">Lobby/&Uuml;bersicht
			~;

   foreach (@{$r_conf}) {
		chomp;
# BIG5
#		my ($conf_id,$conf_name,$conf_desc,$conf_status) = split /::/;
		my ($conf_id,$conf_name,$conf_desc,$conf_status) = split /\|/;
		if ($r_conf_count->{$conf_id} and $r_setup->{'conf_status'}->{$conf_id} eq 'on') {
			$html_forum_links .= "<option value=\"$boardurl\">$conf_name (Conference)";
		   foreach (@{ $r_conf_forums->{$conf_id} }) {
   			$html_forum_links .= qq~
     			<option value="$_">&nbsp;&nbsp;\|--$r_setup->{'forum_name'}->{$_} ($r_setup->{'forum_type'}->{$_} forum)
				~;
			}
		}
	}

  	$html_forum_links .= qq~
		</select>
		<input type="submit" value="GO!"></form>
		</TD>
    </TR>
  </TABLE>
<!-- END FORUM LINKS -->
    ~;
		
   $html_forum_links;
}


###
### subroutine initialize - used by dcboard.cgi and dcadmin.cgi
###
### initializes various parameter
###

sub initialize {

  my ($datadir,$forum_file,$board_setup_file) = @_;

  my $r_setup = {};

  $r_setup->{'board_setup'} = {};

  my %desc = (
  bg_color_0 => "Hintergrundfarbe 0",
  font_color_0 => "Font Farbe 0",
  font_face_0 => "Font Face 0",
  font_size_0 => "Font Gr&ouml;sse 0",
  bg_color_1 => "Hintergrundfarbe 1",
  font_color_1 => "Font Farbe 1",
  font_face_1 => "Font Face 1",
  font_size_1 => "Font Gr&ouml;sse 1",
  bg_color_2 => "Hintergrund Farbe 2",
  font_color_2 => "Font Farbe 2",
  font_face_2 => "Font Face 2",
  font_size_2 => "Font Gr&ouml;sse 2",
  bg_color_3 => "Hintergrund Farbe 3",
  font_color_3 => "Font Farbe 3",
  font_face_3 => "Font Face 3",
  font_size_3 => "Font Gr&ouml;sse 3",
  mesg_max => "Anzahl der Beitr&auml;ge die je Seite angezeigt werden",
  level_max => "Max. Anzahl der Antworten die je Beitrag angezeigt werden sollen",
  level_spacing => "Spacing zwischen den Icons",
  subject_length_max => "Max. L&auml;nge des Themas das angezeigt wird",
  word_length_max => "Max. Anzahl Zeichen pro Beitrag",
  max_messages => "Autosensing ab wievielen Beitr&auml;gen?",
  max_threads_allowed => "Max. Anzahl Beitr&auml;ge pro Forum",
  use_icons => "Icons f&uuml;r die Navigation benutzen?",
  use_icons_toc => "Icons in den Beitr&auml;gen benutzen?",
  display_caption => "Beschreibung unter den Themen anzeigen?",
  caption_length => "Max. L&auml;nge der Beschreibung",
  table_width => "Table Breite (Mit % Zeichen wenn Sie den Wert in Prozent benutzen)",
  hide_private => "Private Foren in der Lobby verstecken?",
  icon_text => "Text unter den Icons anzeigen?",
  show_orig_mesg => "Original Message immer qouten?",
  edit_allowed => "Bearbeiten der Nachrichten erlauben?",
  html_allowed => "HTML Tags erlauben?",
  image_allowed => "Grafiken/Links erlauben?",
  conf_listing => "Nur Forengruppen in der Lobby anzeigen?",
  threaded_main_listing => "In den Nachrichten Verzeichnis-Baum anzeigen?",
  threaded_discussion => "Gruppen als Verzeichnis-Baum anzeigen?",
  reverse_thread => "Nachrichten r&uuml;ckw&auml;rts anzeigen?",
  message_indent => "Nachrichten als Baum anzeigen?",
  bad_word_list => "Unerlaubte W&ouml;rter anzeigen",
  email_to_admin => "Admin eine Mail bei neuen Beitr&auml;gen senden?",
  email_to_mod => "Moderator eine Mail bei neuen Beitr&auml;gen senden?",
  email_notification => "Usern die Email Benachrichtigung erlauben?"
);

   $r_setup->{'setup_desc'} = \%desc;

# BIG5
# IF BIG 5, REPLACE ALL "|" WITH "::" BELOW
   my @variables = qw(
bg_color_0|#999999
font_color_0|#FFFFFF
font_face_0|Verdana
font_size_0|2
bg_color_1|#FFFFFF
font_color_1|#000099
font_face_1|Verdana
font_size_1|2
bg_color_2|#EEEEEE
font_color_2|#000099
font_face_2|Verdana
font_size_2|2
bg_color_3|#EEEEEE
font_color_3|#000099
font_face_3|Verdana
font_size_3|2
mesg_max|30
level_max|12
level_spacing|18
subject_length_max|35
word_length_max|40
max_messages|20
max_threads_allowed|200
message_indent|on
hide_private|on
use_icons|on
use_icons_toc|on
display_caption|on
caption_length|150
table_width|100%
icon_text|off
show_orig_mesg|off
html_allowed|off
edit_allowed|on
image_allowed|on
conf_listing|off
threaded_main_listing|off
threaded_discussion|on
reverse_thread|on
email_to_admin|off
email_to_mod|off
email_notification|off
bad_word_list|fuck,shit,tit,motherfuck,dick,blowjob,ficken,hure,nutte,schwanz,blasen,
);				

	unless (-e "$datadir/$board_setup_file") {
	  check_datafile("$datadir/$board_setup_file",\@variables);
	}
	unless (-e "$datadir/$forum_file") 	{
	  check_datafile("$datadir/$forum_file");
	}
	unless (-e "$datadir/$conf_file") 	{
	  check_datafile("$datadir/$conf_file");
	}

  get_conf_info("$datadir/$conf_file",$r_setup);
  get_forum_info("$datadir/$forum_file",$r_setup);
  get_setup_variables("$datadir/$board_setup_file",$r_setup->{'board_setup'});

  return $r_setup;

}

####
#
# subroutine get_user_mark
# reads in user time mark file
#
####

sub get_user_mark {

   my ($r_in, $r_setup) = @_;

   my $r_user_mark = {};

   if ($r_in->{'userdata'}->{'Username'}) {
      my $user_file = "$password_file_dir/$r_in->{'userdata'}->{'Username'}.log";
      check_datafile($user_file,"");
      my $r_rows = readdata_nolock($user_file);

      foreach (@{$r_rows}) {
         chomp;
         my ($forum_name,$lastread) = split /=/;
         $r_user_mark->{$forum_name} = $lastread;
      }#End of foreach

      return $r_user_mark;

   }#End of if ($username)...
   else {
      return 0;
   }

}

###
### subroutine get_user_login_data
### Read in all the username and password
### Then, pull off the record that matches
### Input username
###

sub get_userdata {

   my ($session_file) = @_;
   my $r_data = readdata_nolock($session_file);
   my $r_local = {};
	
   foreach (@{$r_data}) {
      chomp;
		($key,$value) = split(/::/,$_);
		$r_local->{$key} = $value;
   }

	return $r_local;

}


#####
#
# Function access_error
# Eliminates remote posting
####

sub access_error {

	my ($error,$r_in,$r_setup) = @_;
	my ($heading,$sub_heading,$html_output);
	
	if ($error eq 'forum off') {
		$heading = "FEHLER: Kein Zugriff auf das Forum moeglich";
      $sub_heading = qq~
			<p><b>"$r_setup->{'forum_name'}->{$forum}"
      	Dieses Forum ist derzeit nicht aktiv<br>
      	Bitte kontakten Sie den Webmaster fuer weitere Informationen</b><p>
		~;
      $html_output = "";
	}
	elsif ($error eq 'forum private') {
      $heading = "FEHLER: Kein Zugriff auf das private Forum";
		$sub_heading .= qq~
		<p><font size="4"><b>"$r_setup->{'forum_name'}->{$forum}" ist ein Privates Forum<br>
		Sie haben keine Zugriffserlaubnis auf dieses Forum, kontakten Sie den Forum Admin
		wenn Sie sich in diesem Forum beteiligen moechten.</b>
		<p>Vielen Dank!</font><p>~;
      $html_output = "";

	}
	elsif ($error eq 'remote posting') {

	    $heading = "DCProtect User Manager";
	    $sub_heading = "FEHLER: Der UserManager ist nicht aktiviert";
	    $html_output .= qq~
	    <h4 align="center">
	    Der Webmaster hat den Zugriff auf den UserManager deaktiviert.
	    Schreiben Sie eine Mail an den Webmaster um Ihr Passwort zu aendern.</h4>
	    ~;

	}
	
	return ($heading,$sub_heading,$html_output);
}

####
# check_forum_access
# Checks user group and access list
# returns 0 or 1
####

sub check_forum_access {

	my ($r_in,$r_setup,$forum) = @_; 

   my $access = "1";

	if ($r_setup->{'forum_type'}->{$forum} eq 'Private') {
		if ($r_setup->{'board_setup'}->{'hide_private'} ne "on" && $r_in->{'az'} eq '') {
		   $access = 1;
		}
		else {
			unless ($r_in->{'userdata'}->{'Group'} eq "admin" or
				$r_in->{'userdata'}->{'Username'} eq $r_setup->{'forum_owner'}->{$forum} or
					$r_in->{'userdata'}->{'Forums'} =~ /$forum/) {
	    		$access = "0";
	   	}
		}
	}

	return $access;

}

###
#
# get_forum_info
#
###

sub get_conf_info {

	my($conf_file,$r_setup) = @_;

	my $r_lines = readdata($conf_file);
	foreach (@$r_lines) {
		chomp;
# BIG5
#		my @temp = split /::/;
		my @temp = split /\|/;
		push(@{$r_setup->{'conf'}},$temp[0]);
		$r_setup->{'conf_name'}->{$temp[0]} = $temp[1];
		$r_setup->{'conf_desc'}->{$temp[0]} = $temp[2];
		$r_setup->{'conf_status'}->{$temp[0]} = $temp[3];
	}
}

###
#
# save_conf_info
#
###

sub save_conf_info {

	my ($forum_file,$r_setup) = @_;

	foreach $forum (@{$r_setup->{'forums'}}) {

# BIG5
#			my $temp = join("::",
			my $temp = join("\|",
			$forum,
			$r_setup->{'forum_conf'}->{$forum},
			$r_setup->{'forum_name'}->{$forum},
			$r_setup->{'forum_desc'}->{$forum},
			$r_setup->{'forum_owner'}->{$forum},
			$r_setup->{'forum_owner_email'}->{$forum},
			$r_setup->{'forum_type'}->{$forum},
			$r_setup->{'forum_status'}->{$forum},
			$r_setup->{'forum_last'}->{$forum},
			$r_setup->{'forum_threads'}->{$forum},
			$r_setup->{'forum_archive'}->{$forum} );
		push(@new_row,"$temp\n");
	}

	writedata($forum_file,\@new_row);

}

####
#
# get_team_members
###

sub get_team_members {

	my ($team_file) = shift;
	my $r_team = [];
	if (-e "$team_file") {
   	$r_team = readdata("$team_file");
	}
	$team = join(" ",@{$r_team});
	return $team;
}

####
#
# get_session
####

sub get_session {

	my $r_temp = {};
	$session = get_cookie($cookie_name);
	if ($session) {
   	if (-e "$password_file_dir/$session.session") {
      	$r_temp = get_userdata("$password_file_dir/$session.session");
   	}
   	else {
      	send_cookie($cookie_name,'','Thur, 31-Dec-98 12:00:00 GMT','');
      	$session = '';
   	}
	}

	return $r_temp;
}
1;

